#!/bin/bash

#
# Functions
#

function write_module_file {

# Save module configuration

local MODULES=${@}

cat > modules.sh << __EOF
module purge
module load ${MODULES}
__EOF

}

#
# Machine-dependent setup of compilation
#

case ${HOST} in # Machine name
  
  *theia*)
    
    # Intel Fortran
    
    export FC=ifort
    
    MODULES="intel netcdf nco" 
    
    # Load modules
    
    module purge
    module load ${MODULES}
    
    # Save module configuration
    
    write_module_file ${MODULES}
    
    # Module information:
    
    module list
  
  ;;
  
  *)
    
#    export FC=pgf95
#    export NETCDF=/usr/local/netCDF/netcdf-4.0-pgi

    if [[ x${FC}x == xx || x${NETCDF}x == xx ]] ; then
      
      echo ""
      echo "Set the environment variables"
      echo ""
      echo "FC (Fortran compiler)"
      echo "NETCDF (path to netCDF library)"
      echo ""
      echo "Then run compile.sh again."
      echo ""
      exit
      
    fi
    
  ;;
    
esac

make delog
make $@
