PROGRAM memory_leak_demo_1
  
  USE netcdf
  USE module_netcdf
  
  IMPLICIT NONE
  
  ! Variables
  
  INTEGER, PARAMETER :: dp = kind(0.0D0)
  INTEGER, PARAMETER :: strlen = 32
  
  CHARACTER (LEN=strlen) :: archive,var_name
  
  INTEGER :: x_n,y_n,z_n
  
  REAL(dp), DIMENSION(:,:,:), ALLOCATABLE :: data_xyz
  
  ! Create the data array
  
  x_n = 400
  y_n = 400
  z_n = 222
  
  ALLOCATE(data_xyz(x_n,y_n,z_n))
  
  data_xyz(:,:,:) = 1.0_dp
  
  ! Create the archives and write the data
  
  archive = 'test.nc'
  var_name = 'VAR1'
  CALL write_netcdf(archive,var_name,x_n,y_n,z_n,data_xyz)
  
  WRITE(*,*) ''
  WRITE(*,*) 'Done writing.'
  WRITE(*,*) ''
  
  ! Read the data
  
  archive = 'test.nc'
  var_name = 'VAR1'
  CALL read_netcdf(archive,var_name,x_n,y_n,z_n,data_xyz)
  
  WRITE(*,*) ''
  WRITE(*,*) 'Done reading.'
  WRITE(*,*) ''
  
  ! Cleanup
  
  DEALLOCATE(data_xyz)
  
END PROGRAM memory_leak_demo_1
